// r13client.c

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>


void fatal_error(char *s) {
    perror(s);
    exit(1);
}

#define BUFSIZE 500
#define SRVPORT 7777

int main(int argc, char *argv[]) {
   int sockfd;
   struct hostent *host_info;
   struct sockaddr_in target_addr;
   unsigned char buffer[BUFSIZE];

   if(argc < 2) {
      printf("Usage: %s <hostname>\n", argv[0]);
      exit(1);
   }

   if((host_info = gethostbyname(argv[1])) == NULL)
      fatal_error("looking up hostname");

   if ((sockfd = socket(PF_INET, SOCK_STREAM, 0)) == -1)
      fatal_error("socket");

   target_addr.sin_family = AF_INET;
   target_addr.sin_port = htons(SRVPORT);
   target_addr.sin_addr = *((struct in_addr *)host_info->h_addr);
   memset(&(target_addr.sin_zero), '\0', 8); // Zero the rest of the struct.

   if (connect(sockfd, (struct sockaddr *)&target_addr, sizeof(struct sockaddr)) == -1)
      fatal_error("connecting to target server");

   printf("please insert your string: ");

   fgets(buffer, BUFSIZE, stdin);

   printf("\nsending string to server... ");

   int len = strlen(buffer);
   send(sockfd, buffer, len, 0);

   printf("\nserver answer:\n");
   recv(sockfd, buffer, len, 0);
   printf("%s", buffer);

   recv(sockfd, buffer, len, 0);
   printf("%s\n",buffer);

   exit(0);
}
