// r13exploitfunc.h

// show error and quit
void fatal_error(char *s) {
   perror(s);
   exit(1);
}

/* Accepts a socket FD and a ptr to a null terminated string.
 * Will make sure all the bytes of the string are sent.
 * Returns 1 on success and 0 on failure.
 */
int send_string(int sockfd, unsigned char *buffer) {
   int sent_bytes, bytes_to_send;
   bytes_to_send = strlen(buffer);
   while(bytes_to_send > 0) {
      sent_bytes = send(sockfd, buffer, bytes_to_send, 0);
      if(sent_bytes == -1)
         return 0; // return 0 on send error
      bytes_to_send -= sent_bytes;
      buffer += sent_bytes;
   }
   return 1; // return 1 on success
}

// dumps raw memory in hex byte and printable split format
void dump(const unsigned char *data_buffer, const unsigned int length) {
    unsigned char byte;
    unsigned int i, j;
    for(i=0; i < length; i++) {
        byte = data_buffer[i];
        printf("%02x ", data_buffer[i]);  // display byte (hex)
        
        if(((i%16)==15) || (i==length-1)) {
            for(j=0; j < 15-(i%16); j++)
                printf("   ");
            printf("| ");
            for(j=(i-(i%16)); j <= i; j++) {  // display printable bytes
                byte = data_buffer[j];
                if((byte > 31) && (byte < 127)) // printble 
                    printf("%c", byte);
                else 
                    printf(".");
            }
            printf("\n"); 
        }
    } 
}

// rot13 encoding/decoding of NULL terminated string
void rot13(char *buf) {
    int i = 0;
    unsigned char c;
    for (i=0; c = buf[i]; i++)
        buf[i] =  isalpha(c) ? tolower(c) <'n' ? c+13 : c-13 : c;
    buf[i] = '\0';
}

